﻿var xPag = $("#xPag").val();
var pagActual = 1;

function ListaResultados(inicio, fin) {
    //eliminamos la clase de in...
    $(".gradeX").removeClass('in');

    for (var i = inicio; i <= fin; i++) {
        //para cada elemento
        var identificador = "#datatable-editable > tbody > tr:nth-child(" + i + ")";
        $(identificador).addClass('in');
    }
}

function quitarActivo() {
    $("#paginador button").removeClass('active');
}

function ActualizarElementosPaginador() {
    var paginador = document.querySelectorAll('#paginador button');
    var totalPaginas = $('#paginador button').length > 1 ? parseInt($('#paginador button').length) - 2 : $('#paginador button').length;

    if (totalPaginas > 6) {
        //ocultamos todas las paginas
        $("#paginador button").removeClass('in');
        //activamos solo 10 paginas...
        var inicio = parseInt(pagActual) - 5;
        var fin = parseInt(pagActual) + 4;
        //hay que tener cuidado con los extremos del paginador

        if (inicio < 1) {
            var diferencia = parseInt(1) - parseInt(inicio);
            inicio = parseInt(inicio) + parseInt(diferencia);
            fin = parseInt(fin) + parseInt(diferencia);
        }

        if (fin > totalPaginas) {
            var diferencia = parseInt(fin) - parseInt(totalPaginas);
            inicio = parseInt(inicio) - parseInt(diferencia);
            fin = totalPaginas;
        }

        if (inicio < 1) {
            inicio = 1;
        }

        for (var i = inicio; i <= fin; i++) {
            var pagina = "#paginador > button:nth(" + i + ")";
            $(pagina).addClass('in');
        }
    }
}

function ActualizarVista(indice) {
    quitarActivo();

    var totalPaginas = $('#paginador button').length > 1 ? parseInt($('#paginador button').length) - 2 : $('#paginador button').length;
    if (totalPaginas == 1)
    {
        var botonActivar = "#paginador > button:nth(0)";
        $(botonActivar).addClass('active');
    }
    else {
        var botonActivar = "#paginador > button:nth(" + indice + ")";
        $(botonActivar).addClass('active');
    }

    pagActual = indice;
    var o = parseInt((indice - 1) * xPag) + parseInt(1);
    var h = indice * xPag;
    ListaResultados(o, h);
    //cambiar paginador
    ActualizarElementosPaginador();

    ActualizarLabel();

    //desahabilitar el paginador de siguiente
    if (parseInt($("#paginador > button").length) - 2 == pagActual) {
        $('.siguiente').addClass('disabled');
    }
    else {
        $('.siguiente').removeClass('disabled');
    }

    //desahabilitar el paginador de anterior
    if (pagActual == 1) {
        $('.anterior').addClass('disabled');
    }
    else {
        $('.anterior').removeClass('disabled');
    }
}

function ActualizarLabel() {
    var totalPaginas = $('#paginador button').length > 1 ? parseInt($('#paginador button').length) - 2 : $('#paginador button').length;
    var text = "Pág. " + pagActual + "/" + totalPaginas;
    $("#lblNumPag").text(text);
}

function irPagina() {
    var indice = $("#irNumPag").val();
    if (indice != "") {
        var totalPaginas = $('#paginador button').length > 1 ? parseInt($('#paginador button').length) - 2 : $('#paginador button').length;        
        if ((indice > 0) && (indice <= totalPaginas)) {
            ActualizarVista(indice);
        }
        else {
            alert('Usted a ingresado una página incorrecta. Recuerde que el máximo de páginas se muestra en el label anterior que es igual a ' + totalPaginas);
        }
        $("#irNumPag").val("");
    }
}

ListaResultados(1, xPag);

$(document).ready(function () {
    ActualizarLabel();

    // anniadir el listener al paginador
    var paginador = document.querySelectorAll('#paginador button');
    for (var i = 0; i < paginador.length; i++) {
        paginador[i].addEventListener('click', function () {

            var indice = parseInt(this.textContent);

            //caso especial en el que se esta haciendo click en los botones de anterior o siguiente
            if ($(this).hasClass('anterior')) {
                indice = pagActual - 1;
            }
            else if ($(this).hasClass('siguiente')) {
                indice = pagActual + 1;
            }

            ActualizarVista(indice);
        });
    }

    //vamos annidir un listener a los eventos de la orden de produccion para cuando este seleccionado se quede solo uno
    $("#IdLote").on("change", function () {
        var valorIdLote = $("#IdLote").val();
        var estadoInactivo = $("#estadoInactivo").val();
        if ((valorIdLote > 0) && (estadoInactivo == "0"))
        {
            $("#IdEstado").val(3);
        }
    });
});